/*
 * CreditCardFinder.java
 *
 * Created on January 14, 2002, 5:23 PM
 */

package unleashed.ch2;

/**
 *
 * @author  Stephen Potts
 * @version
 */

import java.io.*;
import java.util.*;
import javax.transaction.*;
import javax.naming.*;

import java.sql.*;
import javax.mail.*;
import javax.mail.internet.*;

/**
 * @author Steve Potts
 */
public class CreditCardFinder
{
    //JDBC variables
    java.sql.Connection dbConn = null;
    Statement statement1 = null;
    
    
    public CreditCardFinder() throws Exception
    {
        init();
    }
    
    //The init() method moves real processing out of the constructors where
    //Exception handling is simpler
    private void init() throws Exception
    {
        try
        {
            //Obtain connections to JDBC and JavaMail
            ConnectToServices();
            
        }catch(Exception e)
        {
            System.out.println("Exception thrown " + e);
        }
    }
    
    private void ConnectToServices()
    {
        try
        {
            //Get a connection to the datasource
            //load the driver class
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            
            //Specify the ODBC data source
            String sourceURL = "jdbc:odbc:CruiseTicket";
            
            //get a connection to the database
            dbConn =DriverManager.getConnection(sourceURL);
            
            //If we get to here, no exception was thrown
            System.out.println("The database connection is " + dbConn);
            System.out.println("Making connection...\n");
            
            //Create the statement
            statement1 = dbConn.createStatement();
            
        } catch (Exception e)
        {
            System.out.println("Exception was thrown: " + e);
        }
    }
    
    private void addCreditCardNumber(Customer cust) throws Exception
    {

        int custID = cust.getCustID();
        
        String ccNum = "";
        
        //Populate the creditcard string string
        String getCCString =
        "SELECT CreditCardNumber FROM CruiseCustomer " +
        "WHERE CustomerID = " + Integer.toString(custID);
        
        ResultSet ccResults = statement1.executeQuery(getCCString);
        
        while (ccResults.next())
        {
            ccNum = ccResults.getString("CreditCardNumber");
        }
        
        cust.setCreditCardNumber(ccNum);
    }
    
    
    private static void log(String s)
    {
        System.out.println(s);
    }
    
    /**
     * main() method.
     *
     * @exception  Exception if execution fails
     */
    public static void main(String[] args) 
    {
        try
        {
            CreditCardFinder ccf = new CreditCardFinder();
            Customer cust1 = new Customer(1001);

            ccf.addCreditCardNumber(cust1);
            System.out.println("The credit card Number for " + 
                        cust1.getCustID() + " = " +
                        cust1.getCreditCardNumber());
         }catch (Exception e)
        {
            System.out.println("Exception in main() " + e);
        }
    }
}
