/*
 * TicketAgentImpl.java
 *
 * Created on January 14, 2002, 5:23 PM
 */

package unleashed.ch2;

/**
 *
 * @author  Stephen Potts
 * @version
 */

import java.io.*;
import java.util.*;

import java.sql.*;
import java.rmi.*;
import java.rmi.server.*;

/**
 *
 * @author Steve Potts
 */
public class TicketAgentImpl
                 extends UnicastRemoteObject
                 implements TicketAgent
{
    static int ticketID = 7000;
    private boolean quit = false;
    //JDBC variables
    java.sql.Connection dbConn = null;
    Statement statement1 = null;
    
 
    public TicketAgentImpl() throws Exception
    {
        init();
    }
    
    //The init() method moves real processing out of the constructors where
    //Exception handling is simpler
    private void init() throws Exception
    {
        try
        {
            //Obtain connections to JDBC 
            ConnectToServices();
            
        }catch(Exception e)
        {
            System.out.println("Exception thrown " + e);
        }
    }
    
    private void ConnectToServices()
    {
        try
        {
            //Get a connection to the datasource
             //load the driver class
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");       
           
            //Specify the ODBC data source
            String sourceURL = "jdbc:odbc:CruiseTicket";
            
            //get a connection to the database
            dbConn =DriverManager.getConnection(sourceURL);
            
            //If we get to here, no exception was thrown
            System.out.println("The database connection is " + dbConn);
            System.out.println("Making connection...\n");
            
            //Create the statement
            statement1 = dbConn.createStatement();
                     
        } catch (Exception e)
        {
            System.out.println("Exception was thrown: " + e);
        }
    }
    
    
    public void respondToRequest(TicketRequest tr)
    {
        try
        {
            String msgText = "";
            
            //get the credit card number from the database
            String ccNum = getCreditCardNumber(tr.getCustID());
            System.out.println("The Credit Card Number is " + ccNum);
            
            //create a queue send to the Payment queue
            if (verifyCreditCard(ccNum))
            {
                buildTicket(tr);
                tr.approve();
            }else
                tr.disApprove();
            
            //if the queue receives a text message to quit, the process ends
            if (msgText.equalsIgnoreCase("quit"))
            {
                synchronized(this)
                {
                    quit = true;
                    this.notifyAll(); // Notify main thread to quit
                }
            }
        }catch (Exception e)
        {
            e.printStackTrace();
        }
    }
    
    
    
    //This method creates a database entry for the new ticket
    private void buildTicket(TicketRequest tr) throws Exception
    {
        String insertStatement;
        ticketID += 1;
        insertStatement = "INSERT INTO CruiseTicket VALUES(" + ticketID + "," +
        Integer.toString(tr.getCustID()) + ", 'Unleashed Cruise Line'," +
        "'USS SeaBuscuit', '" + tr.getPort() + "','" + tr.getSailing() +"'," +
        "999.99," + "0,"+ "0,"+ "'')";
        
        statement1.executeUpdate(insertStatement);
        System.out.println("Update was successful CustID = " + tr.getCustID());
    }
    
    private String getCreditCardNumber(int CustID) throws Exception
    {
        System.out.println("getCreditCard Making Database connection...\n");
        
        String ccNum = "";
        
        //Populate the creditcard string string
        String getCCString =
        "SELECT CreditCardNumber FROM CruiseCustomer " +
        "WHERE CustomerID = " + Integer.toString(CustID);
        
        ResultSet ccResults = statement1.executeQuery(getCCString);
        
        while (ccResults.next())
        {
            ccNum = ccResults.getString("CreditCardNumber");
        }
        
        return ccNum;
    }
    
    private boolean verifyCreditCard(String ccNum)
    {
        int firstNum = Integer.parseInt(ccNum.substring(0,1));
        
        if ( firstNum > 4)
            return false;
        else
            return true;
    }
         
    private void log(String s)
    {
        System.out.println(s);
    }
    
    
    public Object createTicket(Object obj) throws RemoteException
    {
        TicketRequest tr = (TicketRequest)obj;
        respondToRequest(tr);
        return tr;
    }
    
}
