/*
 * TicketRequestDOMParser.java
 *
 * Created on January 19, 2002, 5:33 PM
 */

package unleashed.ch3;

import unleashed.TicketRequest2;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import java.io.*;

import org.w3c.dom.Document;
import org.w3c.dom.DOMException;
import org.w3c.dom.Node;
import org.w3c.dom.*;

/**
 *
 * @author  Stephen Potts
 * @version
 */
public class TicketRequestDOMParser
{
    static Document document;
    TicketRequest2 tr2;
    String eleName;
    
     
      public TicketRequestDOMParser()
      {
          DocumentBuilderFactory factory =
               DocumentBuilderFactory.newInstance();
          try
          {
              tr2 = new TicketRequest2();
              DocumentBuilder builder = factory.newDocumentBuilder();
              document = builder.parse( new File(
              "C:/unleashed/ch3/ticketRequest.xml"));
              traverse(document);
          }catch (SAXException sxe)
          {
              Exception e = sxe;
              if (sxe.getException() != null)
                  e = sxe.getException();
              e.printStackTrace();
          }
          catch (ParserConfigurationException pce)
          {
              pce.printStackTrace();
          }
          catch (IOException ioe)
          {
              ioe.printStackTrace();
          }
      }
      
      private void traverse(Node cNode)
      {
          switch (cNode.getNodeType() )
          {
              case Node.DOCUMENT_NODE:
                  System.out.println("Element " + cNode.getNodeName());
                  processChildren( cNode.getChildNodes());
                  break;
                  
              case Node.ELEMENT_NODE:
                  eleName = cNode.getNodeName();
                  System.out.println("Element " + eleName);
                  NamedNodeMap attributeMap = cNode.getAttributes();
                  int numAttrs = attributeMap.getLength();
                  for (int i=0; i<attributeMap.getLength(); i++)
                  {
                      Attr attribute = (Attr)attributeMap.item(i);
                      String attrName =  attribute.getNodeName();
                      String attrValue = attribute.getNodeValue();
                      storeElementValue(attrName, attrValue);
                  }
                  if (eleName.equals("isCommissionable"))
                  {
                      storeElementValue("isCommissionable", "");
                  }
                  
                  processChildren( cNode.getChildNodes());
                  break;
              case Node.CDATA_SECTION_NODE:
              case Node.TEXT_NODE:
                  
                  System.out.println("Text " + cNode.getNodeValue());
                  if (! cNode.getNodeValue().trim().equals(""))
                  {
                      System.out.println("eleName " + eleName);
                      System.out.println("Text " + cNode.getNodeValue());
                      storeElementValue(eleName, cNode.getNodeValue());
                  }
                  break;
          }
      }
      
      private void processChildren(NodeList nList)
      {
          if(nList.getLength() != 0)
          {
              for (int i=0; i<nList.getLength(); i++)
                  traverse(nList.item(i));
          }
      }
      
      
      private void storeElementValue(String elementName,
                                     String elementValue)
      {
          if (elementName.equals("ticketRequest"))
          {
          }
          
          if (elementName.equals("custID"))
          {
              tr2.setCustID(Integer.parseInt(elementValue));
          }
          
          if (elementName.equals("lastName"))
          {
              tr2.setLastName(elementValue);
          }
          
          if (elementName.equals("firstName"))
          {
              tr2.setFirstName(elementValue);
          }
          
          if (elementName.equals("cruiseID"))
          {
              tr2.setCruiseID(Integer.parseInt(elementValue));
          }
          
          if (elementName.equals("destination"))
          {
              tr2.setDestination(elementValue);
          }
          
          if (elementName.equals("port"))
          {
              tr2.setPort(elementValue);
          }
          
          if (elementName.equals("sailing"))
          {
              tr2.setSailing(elementValue);
          }
          
          if (elementName.equals("numberOfTickets"))
          {
              String numberOfTicketsString = elementValue;
              int numberOfTickets = 
                   Integer.parseInt(numberOfTicketsString);
              tr2.setNumberOfTickets(numberOfTickets);
          }
          
          if (elementName.equals("isCommissionable"))
          {
              tr2.setCommissionable(true);
          }
      }
      
      public String toString()
      {
          return tr2.toString();
      }
      
      
      public static void main(String args[])
      {
          TicketRequestDOMParser  tp = new TicketRequestDOMParser();
          System.out.println(tp);
      }
      
}

