package unleashed.ch4.cruise;


/*  A simple JavaBean to hold a message. 
    This bean will be used to transfer a text
    message between the Controller Servlet and the JSP view.
    By using this mechanism, we can put a little bit of logic 
    into a JSP page and only need a single JSP page instead of 
    multiple ones for responses back to the user.
*/

public class ResponseMessage implements java.io.Serializable
{
    private int messageType;  // 0 is a normal message, 
                              //1 is a warning, 
                              //2 is an error message
    private String messageText; // The text of the message.

    public ResponseMessage()
    {
    }

    public ResponseMessage(int level, String str)
    {
        messageType = level;
        messageText = str;
    }
    public void setMessageType (int level)
    {
        messageType = level;
    }
    public int getMessageType()
    {
        return messageType;
    }
    public void setMessageText(String str)
    {
        messageText = str;
    }
    public String getMessageText()
    {
        return messageText;
    }

    public String toString()
    {
        String response = "Message level: "+messageType+ 
            "   Message is: "+messageText;
        return response;
    }

}