package unleashed.ch5.cruise;

import javax.ejb.*;

/**
* Booking Entity Bean.
*
* @author Alex Pestrikov
*/
public abstract class BookingBean 
implements javax.ejb.EntityBean
{
	/**
	* Entity context
	*/
	private EntityContext ctx;
	 
	/**
	* Business methods
	*/
    public abstract Integer getBookingID();
	public abstract void setBookingID(Integer id);
	
	public abstract String getCruiseName();
	public abstract void setCruiseName(String name);
	
	/**
	* This method is required by the EJB Specification,
	* but is not used by this example.
	* 
	*/
	public void ejbActivate(){}

	/**
	* This method is required by the EJB Specification,
	* but is not used by this example.
	* 
	*/
	public void ejbPassivate(){}

	/**
	* This method is required by the EJB Specification,
	* but is not used by this example.
	* 
	*/
	public void ejbLoad(){}

	/**
	* 
	*/
	public void ejbStore(){}

	/**
	* This method is required by the EJB Specification,
	* but is not used by this example.
	* 
	* @exception               javax.ejb.RemoveException
	*                          if the EJBean does not allow removing the EJBean
	*/
	public void ejbRemove()throws RemoveException{}

	/**
	*
	* @param id         String Booking id
	* @param name    	String cruise name
	* @exception               javax.ejb.CreateException
	*                          if there is a problem creating the bean
	*/
	public Integer ejbCreate(String name) 
    throws CreateException
	{
	
		setCruiseName(name);
    
		return null;  
	}

	/**
	* This method is required by the EJB Specification,
	* but is not used by this example.
	*
	* @param id         String Booking id
	* @param name    	String cruise name
	*/
	public void ejbPostCreate(String name){}
	


	/**
	* Sets the EntityContext for the EJBean.
	* 
	* @param ctx               EntityContext 
	*/
	public void setEntityContext(EntityContext ctx) 
	{
		this.ctx = ctx;
	}

	/**
	* Unsets the EntityContext for the EJBean.
	* 
	*/
	public void unsetEntityContext() 
	{
    	this.ctx = null;
	}


}
