package unleashed.ch9.simple;

/**
* Hello World Web Service Client
*/
public class HelloWorldWebServiceClient
{
    public static void main(String[] args)
    {
        try
        {
            callWS();
        }catch(Exception e)
        {
            e.printStackTrace();
        }
        
        
    }
    
    /**
    * This method calls web service proxy factory to create a proxy. After the proxy is created it calls
    * its methods as if it is a local object. The proxy takes care of all SOAP relevant code.
    */
    private static void callWS()
    throws Exception
    {
        System.out.println("Creating web service");
       
        
        HelloWorldWebServiceBindingClient ws = 
            HelloWorldWebServiceBindingClientFactory.create();
        
        System.out.println("Calling web service");
        
        String result = ws.sayIt();
        
        System.out.println("Web Service returned " + result);
        
    }
}
