//Listing 13.1 The SimpleSMTPClient sends a message to a commercial email account.
/*
 * SimpleSMTPClient.java
 *
 * Created on January 12, 2002, 10:44 AM
 */

package unleashed.ch13;

import javax.mail.*;
import javax.mail.internet.*;
import java.util.*;

/**
 *
 * @author  Stephen Potts
 * @version
 */
public class SimpleSMTPClient
{
    String smtpServer;
    String to;
    String from;
    String subject;
    String body;
    
    /** Creates new SimpleSMTPClient */
    public SimpleSMTPClient()
    {
        setup();
        log("Constructor completed  ");
       
    }
    
    private void setup()
    {
        //This is where you put in the settings for your message
        smtpServer = "mail.bellsouth.net";
        to = "sapotts@bellsouth.net";
        from = "sapotts@bellsouth.net";
        subject = "Unleashed book example";
        body = "This is a test to see if we can send a message";
        log("Setup completed  ");

    }
    
    private void send()
    {
        try
        {
            log("Sending a message to " + to);

            //This is the code that does the sending of the message
            Properties props = System.getProperties();
            
            props.put("mail.smtp.host", smtpServer);
            Session session = Session.getDefaultInstance(props, null);
            
            //Create the new message
            Message msg = new MimeMessage(session);
            
            //Set the send from address
            msg.setFrom(new InternetAddress(from));
            
            //Set the to address
            msg.setRecipients(Message.RecipientType.TO,
            InternetAddress.parse(to, false));
            
            //Set the subject
            msg.setSubject(subject);
            msg.setText(body);
            
            //set the date
            msg.setSentDate(new Date());
            
            //send the message
            Transport.send(msg);
            
            System.out.println("Message was sent");
        }catch (Exception e)
        {
            log("Error sending message  " + e);
        }
    }
    
    private void log(String s)
    {
        System.out.println(s);
    }
    
    public static void main(String[] args)
    {
        SimpleSMTPClient sc = new SimpleSMTPClient();
        sc.send();
        System.out.println("SimpleSMTPClient is done ");
    }
    
}
