/*
 * Test2DGraphics.java
 *
 * Created on February 21, 2002, 10:16 AM
 */

package unleashed.ch15;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.awt.font.*;
import javax.swing.*;

/**
 *
 * @author  Stephen Potts
 * @version
 */
public class Test2DGraphics extends Canvas
{
    
    /** Creates new Test2DText */
    public Test2DGraphics ()
    {
        setBackground(Color.white);
    }
    
    public void paint(Graphics g)
    {
        Graphics2D g2D;
        g2D = (Graphics2D) g;
                     
        //draw the red rectangle
        g2D.setColor(Color.red);
        g2D.drawRect(100,100,60,40);
        
        //draw the blue oval
        g2D.setColor(Color.blue);
        g2D.drawOval(100,100,60,40);
           
        //Draw the green polygon
        GeneralPath path1 = new GeneralPath(GeneralPath.WIND_EVEN_ODD);
        path1.moveTo(0.0f, 0.0f);
        path1.lineTo(0.0f, 50.0f);
        path1.lineTo(50.0f, 100.0f);
        path1.lineTo(75.0f, 50.0f);
        path1.lineTo(75.0f, 0.0f);
        path1.closePath();
        g2D.setColor(Color.green);
        g2D.fill(path1); 

        //Draw the first red polygon
        GeneralPath path2 = new GeneralPath(GeneralPath.WIND_EVEN_ODD);
        path2.moveTo(0.0f, 0.0f);
        path2.lineTo(100.0f, 300.0f);
        path2.lineTo(30.0f, 30.0f);
        path2.closePath();
 
        //position the first red polygon
        AffineTransform aTran = new AffineTransform();
        aTran.setToRotation(-Math.PI/10.0);
        g2D.transform(aTran);
        aTran.setToTranslation(10.0f,250.0f);
        g2D.transform(aTran);
        
        g2D.setColor(Color.red);
        g2D.fill(path2); 
        
        //position and draw the red polygon again
        aTran.setToRotation(-Math.PI/5.0);
        g2D.transform(aTran);
        aTran.setToTranslation(10.0f,10.0f);
        g2D.transform(aTran);
        
        g2D.setColor(Color.red);
        g2D.fill(path2); 
        
        //position and draw the red polygon for the third time
        aTran.setToRotation(-Math.PI/3.0);
        g2D.transform(aTran);
        aTran.setToTranslation(10.0f,10.0f);
        g2D.transform(aTran);
        
        g2D.setColor(Color.red);
        g2D.fill(path2); 
    }
    
    public static void main(String s[])
    {
        
        JFrame frame1 = new JFrame("2D Graphics ");
        frame1.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        frame1.getContentPane().add("Center", new Test2DGraphics ());
        frame1.pack();
        frame1.setSize(new Dimension(500, 500));
        frame1.show();
    }
  
}