/*
 * Test2DImageDraw.java
 *
 * Created on February 22, 2002, 6:47 PM
 */

package unleashed.ch15;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.net.*;
import javax.swing.*;
import java.awt.font.*;

/**
 *
 * @author  Stephen Potts
 * @version
 */

public class Test2DImageDraw extends Canvas
{
    
    /** Creates new Test2DText */
    public Test2DImageDraw()
    {
        setBackground(Color.white);
    }
    
    public void paint(Graphics g)
    {
        try
        {
            Graphics2D g2D;
            g2D = (Graphics2D) g;
            
            g2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
            RenderingHints.VALUE_ANTIALIAS_ON);
            
            String fileName = "c:/unleashed/ch15/snake.jpg";
            
            Image img = getToolkit().getImage(fileName);
            
            AffineTransform aTran = new AffineTransform();
            aTran.translate(50.0f, 20.0f);
            g2D.transform(aTran);
            
            //draw the image 
            g2D.drawImage(img, new AffineTransform(), this);            
            
            //draw the 2 red rectangle close to each other
            g2D.setColor(Color.red);
            g2D.drawRect(0,0,173,230);
            g2D.drawRect(1,1,171,228);
            
            //draw the white oval
            g2D.setColor(Color.white);
            g2D.drawOval(2,2,170,227);
            
           
            //add the text
            FontRenderContext frc = g2D.getFontRenderContext();
            Font font1 = new Font("Courier",Font.BOLD, 8);
            String str1 = new String("Copyright");
            TextLayout tl = new TextLayout(str1, font1, frc);
            Dimension dim1= getSize();
            g2D.setColor(Color.white);
            tl.draw(g2D, 125, 228);
            
            
        }catch (Exception e)
        {}
    }
    
    public static void main(String s[])
    {
        JFrame frame1 = new JFrame("2D Images ");
        frame1.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        frame1.getContentPane().add("Center", new Test2DImageDraw());
        frame1.pack();
        frame1.setSize(new Dimension(300, 300));
        frame1.show();
    }//main
    
}//class