/*
 * Test2DImage.java
 *
 * Created on February 22, 2002, 6:47 PM
 */

package unleashed.ch15;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.net.*;
import javax.swing.*;

/**
 *
 * @author  Stephen Potts
 * @version
 */

public class Test2DImageTran extends Canvas
{
    
    /** Creates new Test2DText */
    public Test2DImageTran()
    {
        setBackground(Color.white);
    }
    
    public void paint(Graphics g)
    {
        try
        {
            Graphics2D g2D;
            g2D = (Graphics2D) g;
            
            g2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
            RenderingHints.VALUE_ANTIALIAS_ON);
            
            String fileName = "c:/unleashed/ch15/snake.jpg";
            Image img = getToolkit().getImage(fileName);
                        
            //draw the original image
            g2D.drawImage(img, new AffineTransform(), this);
                        //move the image over
            AffineTransform aTran = new AffineTransform();
            aTran.translate(200.0f, 0.0f);
            g2D.transform(aTran);
            
            //adjust the scale to enlarge it
            AffineTransform imageSpaceTran = new AffineTransform();
            
            //set how much to shear the picture
            imageSpaceTran.setToShear(0.1f, 0.1f);
            
            //draw the sheared image
            g2D.drawImage(img, imageSpaceTran, this);
            
            //move the image over
            aTran.translate(50.0f, 0.0f);
            g2D.transform(aTran);
            imageSpaceTran.scale(1.3f, 1.3f);
            
            //draw the enlarged image
            g2D.drawImage(img, imageSpaceTran, this);

        }catch (Exception e)
        {}
    }
       
    public static void main(String s[])
    {
        JFrame frame1 = new JFrame("2D Images ");
        frame1.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        frame1.getContentPane().add("Center", new Test2DImageTran());
        frame1.pack();
        frame1.setSize(new Dimension(750, 370));
        frame1.show();
    }//main
      
}//class