/*
 * Minimal3D.java
 *
 * Created on March 25, 2002, 9:54 AM
 */

package unleashed.ch16;

import java.awt.*;
import java.awt.event.*;
import javax.media.j3d.*;
import com.sun.j3d.utils.geometry.Sphere;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.universe.SimpleUniverse;



/**
 *
 * @author  Stephen Potts
 * @version
 */
public class Minimal3D extends Frame
{
    
    /** Creates new Minimal3D */
    public Minimal3D()
    {
        super("Minimal3D");
        setSize(400,300);
        setLayout(new BorderLayout());
        
        GraphicsConfiguration config =
        SimpleUniverse.getPreferredConfiguration();
        Canvas3D canvas3D = new Canvas3D(config);
        
        add("Center", canvas3D);
        setVisible(true);
        
        BranchGroup sGraph = createSceneGraph();
        sGraph.compile();
        
        SimpleUniverse sUniverse = new SimpleUniverse(canvas3D);
        
        sUniverse.getViewingPlatform().setNominalViewingTransform();
        
        sUniverse.addBranchGraph(sGraph);
    }//constructor
    
    public BranchGroup createSceneGraph()
    {
        BranchGroup root = new BranchGroup();
        
        Transform3D rotateX = new Transform3D();
        rotateX.rotX(Math.PI/10.0d);
        Transform3D rotateY = new Transform3D();
        rotateY.rotY(Math.PI/5.0d);
        rotateX.mul(rotateY);
        
        TransformGroup tGroup = new TransformGroup(rotateX);
        tGroup.addChild(new ColorCube(0.3));
        root.addChild(tGroup);
        
        return root;
    }//createSceneGraph()
    
    public static void main(String[] args)
    {
        final Minimal3D m3d = new Minimal3D();
        m3d.addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent e)
            {
                m3d.dispose();
                System.exit(0);
            }
        });
    }
}