/*
 * JPEGResizer.java
 *
 * Created on February 13, 2002, 1:35 PM
 */

package unleashed.ch17;

import java.awt.Frame;
import java.awt.event.*;
import java.awt.image.renderable.ParameterBlock;
import java.io.IOException;
import javax.media.jai.Interpolation;
import javax.media.jai.JAI;
import javax.media.jai.RenderedOp;
import com.sun.media.jai.codec.FileSeekableStream;
import javax.media.jai.widget.ScrollingImagePanel;

/**
 *
 * @author  Stephen Potts
 * @version
 */
public class JPEGResizer extends Frame
{
    
    /** Creates new JPEGResizer */
    public JPEGResizer()
    {
        //handle window events
        addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent we)
            {
                System.exit(0);
            }
        });
        
    }
    
    public static void main(String[] args)
    {
        JPEGResizer frame1 = new JPEGResizer();
        if (args.length != 1)
        {
            System.out.println(
            "Usage: a file parameter must be supplied");
            System.exit(-1);
        }
        
        FileSeekableStream fss = null;
        
        try
        {
            fss = new FileSeekableStream(args[0]);
            
            RenderedOp originalImage = JAI.create("stream", fss);
            
            Interpolation biLine = Interpolation.getInstance(
            Interpolation.INTERP_BILINEAR);
            
            ParameterBlock pb = new ParameterBlock();
            pb.addSource(originalImage);
            pb.add(1.5F);
            pb.add(1.5F);
            pb.add(115.0F);
            pb.add(40.0F);
            pb.add(biLine);
            
            RenderedOp outputImage = JAI.create("scale", pb);
            
            ScrollingImagePanel sip = new ScrollingImagePanel(
            outputImage, 400, 400);
            
            frame1.add(sip);
            frame1.pack();
            frame1.show();
        }catch (IOException ioe)
        {
            System.out.println("IOException " + ioe);
        }
    }
}