/**
* Faade pattern exaple
*/ 

package unleashed.ch21.facade;

/**
* Fund Transfer Faade class
*/
class FundTransfer
{
	public FundTransfer()
	{
    System.out.println("Creating fund transfer facade ");
   	}
	//transfer fund use case
	public void transferFunds(double amount)
	{
		//create from account
		System.out.println("Facade: Getting FROM account");
		Account accountFrom = new Account(1000);

		//create to account
		System.out.println("Facade: Getting TO account");
		Account accountTo  = new Account(400);
		
		//begin atomic transaction	
		accountFrom.withdraw(amount);
		accountTo.deposit(amount);
		//end atomic tarnsaction	
	}
}

/**
* Account object
*/
class Account
{
	protected double balance;
	
	public Account(double amount)
	{
		balance = amount;
	}
	
	public void withdraw(double amount)
	{
		System.out.println("Account: withdrawing funds");
		balance = balance - amount;
	}
	
	public void deposit(double amount)
	{
		System.out.println("Account: depositing funds");
		balance = balance + amount;
	}
}

/**
* Implements client to our faade.
*/
public class FacadeExample
{
	public static void main(String[] args)
	{
		//create new bank facade
		FundTransfer bank = new FundTransfer();

		//transfer funds
		System.out.println("Client: Calling the facade object");
		bank.transferFunds(100.00);

		
	}
}


