package unleashed.ch21.singleton;

/**
* Singleton Connection Pool
*/
public class ConnectionPool
{

	//only one instance is needed
	private static ConnectionPool instance;

	private ConnectionPool()
	{
		//code to instantiate the object
		System.out.println("Creating the single instance of connection pool");
	}

	/**
	* Gets one instance of the connection pool.
	*/
	public static ConnectionPool getInstance()
	{
		if(instance != null)
		{
			//give access to the existing object
			System.out.println("Getting existing instance of connectin pool");
			return instance;
		}
		else
		{
			//no objects exists yet - create one 
			instance = new ConnectionPool();
			return instance;
		}
	}
	
	public static void main(String[] args)
	{
		
		System.out.println("Get connection pool first time");
		
		ConnectionPool cPool = ConnectionPool.getInstance();
		
		System.out.println("Get connection pool second time");
		
		ConnectionPool anotherPool = ConnectionPool.getInstance();
	}
}

