//Listing 22.12 The StackingException class turns the stacks into String objects and //concatenates them together. 
package unleashed.ch22;
import java.io.*;

/**
 *
 * @author  Stephen Potts
 * @version 
 */
abstract class StackingException extends Exception
                              implements Serializable
{
    String stackBuffer = "";
    
    /** Creates new StackingException */
    public StackingException() {
    }
    
    public StackingException(String message, Exception e)
    {
        super(message);

        //turn the stack into a string
        StringWriter s = new StringWriter();
        this.printStackTrace( new PrintWriter(s));
 
        //if this exception is wrapping another,
        // get the old stacktrace and append this
        //stack trace to it
        if (e != null && e instanceof StackingException)
        {
            StackingException se = (StackingException)e;
            stackBuffer  = se.getStackBuffer();
            stackBuffer += s.toString();
         }else
        {
            stackBuffer = s.toString();
        }
            
    }

    public String getStackBuffer()
    {
        return stackBuffer;
    }
    
}