//Listing 22.3 The WaterTemperatureManager class knows nothing but temperatures and 
// times. It gets the water hot and keeps it hot until the time is up.
package unleashed.ch22;
import java.util.*;

/**
 *
 * @author  Stephen Potts
 * @version 
 */
public class WaterTemperatureManager
{
    private Thermometer therm1;
    private WaterValve watValve;
    private int temperature;
    private int duration;
    

    /** Creates new WaterTemperatureManager */
    public WaterTemperatureManager(int temperature, int duration)
    {
        System.out.println("WaterTemperatureManager constructed");
        this.therm1 = new Thermometer();
        this.watValve = new WaterValve();
        this.temperature = temperature;
        this.duration = duration;
    }
    
    //Heat up the water and keep it at the temperature for the duration
    public void startUp()
    {
        try
        {
            Calendar c = Calendar.getInstance();
            boolean done = false;

            System.out.println("WaterTemperatureManager.startUP() - started");

            //get up to temperature
            this.watValve.openValve();
            while (therm1.getTemperature() < this.temperature)
            {
                System.out.println("temperature is now = " +
                                     therm1.getTemperature());
                Thread.sleep(10*60);
                therm1.increaseTemp(); //simulates the water warming up 
            }
            this.watValve.closeValve();

            System.out.println(
            "WaterTemperatureManager.startup - achieved temperature of "
                +  temperature);

            while (!done)
            {
                Thread.sleep(10*60);
                if (therm1.getTemperature() < this.temperature)
                    this.watValve.openValve();
                else
                    this.watValve.closeValve();
                c = Calendar.getInstance();
                System.out.print(
                    "WaterTemperatureManager.startUP() time = ");
                System.out.print(c.get(Calendar.HOUR) +":"+
                   c.get(Calendar.MINUTE) +":"+
                   c.get(Calendar.SECOND));
                System.out.println(" Temperature = "
                  + therm1.getTemperature());
                duration -= 1;
                if (duration == 0)
                    done = true;
            }
            System.out.println(
                   "WaterTemperatureManager.startUP() - ending");
        }catch (InterruptedException ie)
        {
            System.out.println("WaterTemperatureManager.startUp " + ie);
        }
    }
 }
