package unleashed.ch22;
import java.util.*;

/**
 *
 * @author  Stephen Potts
 */
public class WaterTemperatureManager3 
{
    private Thermometer3 therm1;
    private WaterValve watValve;
    private int temperature;
    private int duration;
    

    /** Creates new WaterTemperatureManager */
    public WaterTemperatureManager3(int temperature, int duration)
                throws WaterTemperatureManagerException3
    {
        try
        {
            System.out.println("WaterTemperatureManager constructed");
            this.therm1 = new Thermometer3();
            this.watValve = new WaterValve();
            this.temperature = temperature;
            this.duration = duration;
        }catch (ThermometerException3 te)
        {
             throw new WaterTemperatureManagerException3(
             "Couldn't create a WaterTemperatureManager " +
             "thermometer problem." , te.getTemperature(), te);
         }
    }
          
    
    //Heat up the water and keep it at the temperature for the duration
    public void startUp() throws WaterTemperatureManagerException3
    {
        try
        {
            Calendar c = Calendar.getInstance();
            boolean done = false;

            System.out.println(
                "WaterTemperatureManager.startUP() - started");

            //get up to temperature
            this.watValve.openValve();
            while (therm1.getTemperature() < this.temperature)
            {
                System.out.println("temperature is now = " +
                                     therm1.getTemperature());
                Thread.sleep(10*60);
                therm1.simIncreaseTemp(); // simulates the water warming
            }
            this.watValve.closeValve();

            System.out.println(
                    "WaterTemperatureManager.startUP() - " +
                       " achieved temperature of " +
                            therm1.getTemperature() );

            while (!done)
            {
                Thread.sleep(10*60);
                if (therm1.getTemperature() < this.temperature)
                    this.watValve.openValve();
                else
                    this.watValve.closeValve();
                c = Calendar.getInstance();
                System.out.print(
                        "WaterTemperatureManager.startUP() time = ");
                System.out.print(c.get(Calendar.HOUR) + 
                     ":"+ c.get(Calendar.MINUTE) +":"+
                               c.get(Calendar.SECOND));
                System.out.println(" Temperature = " +
                               therm1.getTemperature());
                duration -= 1;
                if (duration == 0)
                    done = true;
            }
            System.out.println(
                "WaterTemperatureManager.startUP() - ending");
        }catch (InterruptedException ie)
        {
            System.out.println(
                   "WaterTemperatureManager.startUp() " + ie);
            throw new WaterTemperatureManagerException3(
                 "Couldn't start the WaterTemperatureManager timing " +
                 "was interupted by another process ",
                          therm1.getTemperature(), ie);

        }
    }
 }