package unleashed.ch23;

/**
* MyPermissionExample tries to execute method doSomething() that is 
* only allowed to execute if unleashed.ch23.MyPermission permission is given.
*/
public class MyPermissionExample
{
    public static void main(String[] args)
    {
        doSomething();
    }
    
    public static void doSomething()
    {
        //get security manager
        SecurityManager sm = System.getSecurityManager();
        
        if (sm != null)
        {
            //check permission
            sm.checkPermission(new MyPermission(""), sm.getSecurityContext());
        }
        else
            throw new SecurityException("No Security Manager");
        
        
        //do the rest here -- it is allowed by security manager
        System.out.println("doSomething method is allowed to execute;");    
    }
}
