/*
 * I18nCurrencyTest.java
 *
 * Created on February 7, 2002, 1:20 PM
 */

package unleashed.ch25;
import java.util.*;
import java.text.*;

/**
 *
 * @author  Stephen Potts
 * @version
 */
public class I18nCurrencyTest
{
    
    /** Creates new I18nCurrencyTest */
    public I18nCurrencyTest()
    {
    }
    
    static public void displayCurrency(Locale loc, double amount)
    {
         String displayString;
         NumberFormat nf;
        
        //get a formatter for the number
        nf = NumberFormat.getCurrencyInstance(loc);
        
       
        //Format the number into a string
        displayString = nf.format(amount);
        
        //Display the string
        System.out.println(displayString + " " + loc.toString());
    }
   
   

    public static void main(String[] args)
    {
        String lang = "en";
        String country = "US";
        String variant = "";
        Locale loc;
        ResourceBundle rBundle;
        
        //if they passed in a lang and country, use it.  Else
        //use  en US
        if (args.length == 2)
        {
            lang = args[0];
            country = args[1];
        }
        
        if (args.length == 3)
        {
            lang = args[0];
            country = args[1];
            variant = args[2];
            loc = new Locale(lang, country, variant);
        }else
        {
             loc = new Locale(lang, country);
        }
        
        //Display the currency 
        System.out.println("------------------------------------------");
        System.out.println("------------------------------------------");
        displayCurrency(loc, 123456789);
        displayCurrency(loc, 123.456);
        displayCurrency(loc, 123456789.987);
        displayCurrency(loc, 1234.9876543);

        System.out.println("------------------------------------------");
        System.out.println("------------------------------------------");
    }
}