/*
 * I18nDateTimeTest.java
 *
 * Created on February 7, 2002, 1:20 PM
 */

package unleashed.ch25;
import java.util.*;
import java.text.*;

/**
 *
 * @author  Stephen Potts
 * @version
 */
public class I18nDateTimeTest
{
    
    /** Creates new I18nDateTimeTest */
    public I18nDateTimeTest()
    {
    }
    
    static public void displayDate(Locale loc, int format)
    {
        Date today;
        String displayString;
        DateFormat df;
        
        //get a formatter for the date
        df = DateFormat.getDateInstance(format, loc);
        
        //Get the current date
        today = new Date();
        
        //Format the date into a string
        displayString = df.format(today);
        
        //Display the string
        System.out.println(displayString + " " + loc.toString());
    }
   
   
    static public void displayTime(Locale loc, int format)
    {
        Date today;
        String displayString;
        DateFormat df;
        
        //Get a formatter for the time
        df = DateFormat.getTimeInstance(format, loc);
        
        //get the current time of day
        today = new Date();
        
        //create a string containing the time
        displayString = df.format(today);
        
        //Display the time
        System.out.println(displayString + " " + loc.toString());
    }

    public static void main(String[] args)
    {
        String lang = "en";
        String country = "US";
        String variant = "";
        Locale loc;
        ResourceBundle rBundle;
        
        //if they passed in a lang and country, use it.  Else
        //use  en US
        if (args.length == 2)
        {
            lang = args[0];
            country = args[1];
        }
        
        if (args.length == 3)
        {
            lang = args[0];
            country = args[1];
            variant = args[2];
            loc = new Locale(lang, country, variant);
        }else
        {
             loc = new Locale(lang, country);
        }
        
        //Display the current date in a variety of formats
        System.out.println("------------------------------------------");
        System.out.println("------------------------------------------");
        displayDate(loc, DateFormat.DEFAULT);
        displayDate(loc, DateFormat.SHORT);
        displayDate(loc, DateFormat.MEDIUM);
        displayDate(loc, DateFormat.LONG);
        displayDate(loc, DateFormat.FULL);

        System.out.println("------------------------------------------");
        //Display the current time in a variety of formats
        displayTime(loc, DateFormat.DEFAULT);
        displayTime(loc, DateFormat.SHORT);
        displayTime(loc, DateFormat.MEDIUM);
        displayTime(loc, DateFormat.LONG);
        displayTime(loc, DateFormat.FULL);
        System.out.println("------------------------------------------");
        System.out.println("------------------------------------------");
    }
}