/*
 * I18nListBundleTest.java
 *
 * Created on February 7, 2002, 9:13 AM
 */

package unleashed.ch25;
import java.util.*;
import javax.swing.*;

/**
 *
 * @author  Stephen Potts
 * @version
 */
public class I18nListBundleTest
{
    
    /** Creates new I18nListBundleTest */
    public I18nListBundleTest()
    {
    }
    
    public static void main(String[] args)
    {
        String lang = "";
        String country = "";
        String variant = "";
        Locale loc;
        ResourceBundle rBundle;
        
        //if they passed in a lang and country, use it.  Else
        //use the default resource bundle, in this case German
        if (args.length == 2)
        {
            lang = args[0];
            country = args[1];
        }
        
        if (args.length == 3)
        {
            lang = args[0];
            country = args[1];
            variant = args[2];
            loc = new Locale(lang, country, variant);
        }else
        {
            //Create the Locale object
            loc = new Locale(lang, country);
        }
        
        //Use this method to locate the correct bundle for the locale
        rBundle =
        ResourceBundle.getBundle("unleashed.ch25.ImageResources", loc);
        
        //Get the correct flag for this locale
        ImageIcon flagIcon = (ImageIcon)(rBundle.getObject("icon"));
        String[] options =
        {
            rBundle.getString("affirmative"),
            rBundle.getString("negative")};
            
            String dString = rBundle.getString("greet") + " " +
            rBundle.getString("farewell") + " " +
            rBundle.getString("edible") + " " +
            rBundle.getString("wishSuccess");
                       
            //Create an option pane to display the icon and the words
            //in the resource bundle class
            JOptionPane pane = new JOptionPane(
            dString, JOptionPane.QUESTION_MESSAGE, 0, flagIcon, options);
            
            //display the dialog
            JDialog dlg = pane.createDialog(null, "Unleashed");
            dlg.setModal(true);
            dlg.setVisible(true);
            String selection = (String)(pane.getValue());
            
            //Exit the applications
            System.exit(0);
    }
}