
//Listing 26.19 The AutoCloner class uses serialization to perform deep copy cloning.
package unleashed.ch26;
import java.util.*;
import java.io.*;

/**
 *
 * @author  Stephen Potts
 * @version 
 */
public class AutoCloner implements Cloneable, Serializable
{

    /** Creates new AutoCloner */
    public AutoCloner() {
    }

    public Object clone()
    {
        Object clonedObj = null;
        try
        {
            //put the object into a byte array
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            ObjectOutputStream oos = new ObjectOutputStream(baos);
            oos.writeObject(this);
            oos.close();
            
            //read the stream into the copy
            ByteArrayInputStream bais = new ByteArrayInputStream(baos.toByteArray());
            ObjectInputStream ois = new ObjectInputStream(bais);
            clonedObj = ois.readObject();
            ois.close();
        }catch (IOException ioe)
        {
            System.out.println("I/O exception " + ioe);
        }
        catch (ClassNotFoundException cnfe)
        {
           System.out.println("Class not found " + cnfe);
        }
        return clonedObj;

    } 
}

