
package unleashed.ch26;
import java.io.*;
import java.util.*;
import javax.crypto.*;
import java.security.*;
/**
 *
 * @author  Stephen Potts
 * The EncryptedEmployee class
 */
public class EncryptedEmployee implements Externalizable
{
    
    private String name;
    private String creditCardNumber;
    private static SecretKey sKey;
    
    public EncryptedEmployee(String name, String ccn)
    {
        this.name = name;
        this.creditCardNumber = ccn;
    }
    
    public EncryptedEmployee()
    {
    }
    
    public String getName()
    {
        return name;
    }
    
    public String getCreditCardNumber()
    {
        return this.creditCardNumber;
    }
    
    public static void setKey(SecretKey sk)
    {
        sKey = sk;
    }
    
    public void writeExternal(ObjectOutput out) throws IOException
    {
        try
        {
            Cipher cip = Cipher.getInstance("DES/ECB/PKCS5Padding");
            cip.init(Cipher.ENCRYPT_MODE, sKey);
            
            byte output[] = this.creditCardNumber.getBytes();
            byte encrypted[] = cip.doFinal(output);
            
            out.writeObject(this.name);
            out.writeObject(encrypted);
        }catch (NoSuchPaddingException nspe)
        {
            System.err.println("no such padding problem " + nspe);
        }
        catch (BadPaddingException bpe)
        {
            System.err.println("bad padding problem " + bpe);
        }
        catch (NoSuchAlgorithmException nsae)
        {
            System.err.println("algorithm problem " + nsae);
        }
        catch (InvalidKeyException ike)
        {
            System.err.println("key problem " + ike);
        }
        catch (IllegalBlockSizeException ibse)
        {
            System.err.println("block size problem " + ibse);
        }
    }
    
    public void readExternal(ObjectInput in) throws IOException,
    ClassNotFoundException
    {
        System.out.println("readExternal() key = " + sKey);
        try
        {
            Cipher cip = Cipher.getInstance("DES/ECB/PKCS5Padding");
            cip.init(Cipher.DECRYPT_MODE, sKey);
            
            this.name = (String)in.readObject();
            byte encrypted[] = (byte[])in.readObject();
            byte input[] = cip.doFinal(encrypted);
            this.creditCardNumber = new String(input);
        }catch (NoSuchPaddingException nspe)
        {
            System.err.println("no such padding problem " + nspe);
        }
        catch (BadPaddingException bpe)
        {
            System.err.println("bad padding problem " + bpe);
        }
        catch (NoSuchAlgorithmException nsae)
        {
            System.err.println("algorithm problem " + nsae);
        }
        catch (InvalidKeyException ike)
        {
            System.err.println("key problem " + ike);
        }
        catch (IllegalBlockSizeException ibse)
        {
            System.err.println("block size problem " + ibse);
        }
    }
}