
//Listing 26.7 RestoreCompany verifies that the Serializing mechanism is working properly
package unleashed.ch26;
import java.io.ObjectInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Iterator;

/**
 *
 * @author  Stephen Potts
 * Test the restoration of serialized objects
 */
public class RestoreCompany {

    /** Creates new RestoreEmployee */
    public RestoreCompany() {
    }
    
    public static void printCompanyObject(Company c)
    {
        System.out.println("The company name is " + c.getName());
        System.out.println("The company president is " + c.getPresident().getName());
        System.out.println(" ");

        Iterator i = c.getDepartmentIterator();
        while (i.hasNext())
        {
            Department d = (Department)i.next();
            System.out.println("   The department name is " + d.getName());
            System.out.println("   The department manager is " + d.getManager().getName());
            System.out.println(" ");
        }
    }
    public static void main(String[] args)
    {
        try
        {
            String filename = "Company.ser";
            Company comp;
        
            FileInputStream f  = new FileInputStream(filename);
            ObjectInputStream ois = new ObjectInputStream(f);
            comp = (Company)ois.readObject();
            printCompanyObject(comp);
            ois.close();
        }catch (IOException ioe)
        {
            System.out.println("IOException thrown " + ioe);
        }
        catch (ClassNotFoundException cnfe)
        {
            System.out.println("ClassNotFoundException thrown " + cnfe);
        }
    }
}
